<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.1"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Lifinity Dungeon: He_Arc::RPG::CharacterClass Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Lifinity Dungeon
   &#160;<span id="projectnumber">6</span>
   </div>
   <div id="projectbrief">The Lifinity Dungeon is a dungeon with an infinity of room. After each room, you found a harder room. This is why you will pass the eternity of your life in this dungeon</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.1 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><b>He_Arc</b></li><li class="navelem"><b>RPG</b></li><li class="navelem"><a class="el" href="class_he___arc_1_1_r_p_g_1_1_character_class.html">CharacterClass</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pro-attribs">Protected Attributes</a> &#124;
<a href="#friends">Friends</a> &#124;
<a href="class_he___arc_1_1_r_p_g_1_1_character_class-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">He_Arc::RPG::CharacterClass Class Reference<span class="mlabels"><span class="mlabel">abstract</span></span></div>  </div>
</div><!--header-->
<div class="contents">

<p>Class for the <a class="el" href="class_he___arc_1_1_r_p_g_1_1_character_class.html" title="Class for the CharacterClass. A character class is the &quot;type&quot; (the class) of a character,...">CharacterClass</a>. A character class is the "type" (the class) of a character, like a warrior or a wizard. This class contains the base attribute and commons methods of each type of character.  
 <a href="class_he___arc_1_1_r_p_g_1_1_character_class.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="_character_class_8hpp_source.html">CharacterClass.hpp</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for He_Arc::RPG::CharacterClass:</div>
<div class="dyncontent">
 <div class="center">
  <img src="class_he___arc_1_1_r_p_g_1_1_character_class.png" usemap="#He_5FArc::RPG::CharacterClass_map" alt=""/>
  <map id="He_5FArc::RPG::CharacterClass_map" name="He_5FArc::RPG::CharacterClass_map">
<area href="class_he___arc_1_1_r_p_g_1_1_skeleton.html" title="Class for the Skeleton, a class of monster (CharacterClass specialisation) It&#39;s the dead characters o..." alt="He_Arc::RPG::Skeleton" shape="rect" coords="0,56,181,80"/>
<area href="class_he___arc_1_1_r_p_g_1_1_slime.html" title="Class for the Slime, a class of monster (CharacterClass specialisation) A slime is a (small) monster ..." alt="He_Arc::RPG::Slime" shape="rect" coords="191,56,372,80"/>
<area href="class_he___arc_1_1_r_p_g_1_1_warrior.html" title="Class for the Warrior, a class of character (CharacterClass specialisation) The warriors use sword (a..." alt="He_Arc::RPG::Warrior" shape="rect" coords="382,56,563,80"/>
<area href="class_he___arc_1_1_r_p_g_1_1_wizard.html" title="Class for the Wizard, a class of character (CharacterClass specialisation) The wizards have the abili..." alt="He_Arc::RPG::Wizard" shape="rect" coords="573,56,754,80"/>
<area href="class_he___arc_1_1_r_p_g_1_1_necromancer.html" title="Class for the Necromancer, a class of character (Wizard specialisation) The necromancer is a wizard w..." alt="He_Arc::RPG::Necromancer" shape="rect" coords="573,112,754,136"/>
  </map>
</div></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:afff2c38ade3572c32aba94d435d0a99a"><td class="memItemLeft" align="right" valign="top"><a id="afff2c38ade3572c32aba94d435d0a99a"></a>
&#160;</td><td class="memItemRight" valign="bottom"><b>CharacterClass</b> (const <a class="el" href="class_he___arc_1_1_r_p_g_1_1_character_class.html">CharacterClass</a> &amp;character)</td></tr>
<tr class="separator:afff2c38ade3572c32aba94d435d0a99a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aafe993f8df4d10236808bf056074d5cc"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_he___arc_1_1_r_p_g_1_1_character_class.html#aafe993f8df4d10236808bf056074d5cc">CharacterClass</a> (int level, int strength, int agility, int intelligence, int perception, int hp, string name, shared_ptr&lt; <a class="el" href="class_he___arc_1_1_r_p_g_1_1_i_object.html">IObject</a> &gt; object=nullptr)</td></tr>
<tr class="memdesc:aafe993f8df4d10236808bf056074d5cc"><td class="mdescLeft">&#160;</td><td class="mdescRight">Construct a new Character Class object.  <a href="class_he___arc_1_1_r_p_g_1_1_character_class.html#aafe993f8df4d10236808bf056074d5cc">More...</a><br /></td></tr>
<tr class="separator:aafe993f8df4d10236808bf056074d5cc"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad4f8371c791c5994eee4a81d230b27c1"><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="class_he___arc_1_1_r_p_g_1_1_character_class.html">CharacterClass</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_he___arc_1_1_r_p_g_1_1_character_class.html#ad4f8371c791c5994eee4a81d230b27c1">Clone</a> () const =0</td></tr>
<tr class="memdesc:ad4f8371c791c5994eee4a81d230b27c1"><td class="mdescLeft">&#160;</td><td class="mdescRight">Create a clone of the character.  <a href="class_he___arc_1_1_r_p_g_1_1_character_class.html#ad4f8371c791c5994eee4a81d230b27c1">More...</a><br /></td></tr>
<tr class="separator:ad4f8371c791c5994eee4a81d230b27c1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae69612164d99e1c4b84b05912d03d72e"><td class="memItemLeft" align="right" valign="top">virtual string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_he___arc_1_1_r_p_g_1_1_character_class.html#ae69612164d99e1c4b84b05912d03d72e">GetClassTypeName</a> () const =0</td></tr>
<tr class="memdesc:ae69612164d99e1c4b84b05912d03d72e"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the name of the class For exemple; if called with this class, it would return "CharacterClass" or somthings like this.  <a href="class_he___arc_1_1_r_p_g_1_1_character_class.html#ae69612164d99e1c4b84b05912d03d72e">More...</a><br /></td></tr>
<tr class="separator:ae69612164d99e1c4b84b05912d03d72e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac7bd4a9689ccdd9a7035853053d6f889"><td class="memItemLeft" align="right" valign="top"><a id="ac7bd4a9689ccdd9a7035853053d6f889"></a>
virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_he___arc_1_1_r_p_g_1_1_character_class.html#ac7bd4a9689ccdd9a7035853053d6f889">Show</a> () const</td></tr>
<tr class="memdesc:ac7bd4a9689ccdd9a7035853053d6f889"><td class="mdescLeft">&#160;</td><td class="mdescRight">Show the statistics of the character. <br /></td></tr>
<tr class="separator:ac7bd4a9689ccdd9a7035853053d6f889"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:adb691223ee5006f580d4744929fd8c26"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_he___arc_1_1_r_p_g_1_1_character_class.html#adb691223ee5006f580d4744929fd8c26">Interact</a> (const <a class="el" href="class_he___arc_1_1_r_p_g_1_1_character_class.html">CharacterClass</a> &amp;character) const =0</td></tr>
<tr class="memdesc:adb691223ee5006f580d4744929fd8c26"><td class="mdescLeft">&#160;</td><td class="mdescRight">Make an interaction between 2 characters.  <a href="class_he___arc_1_1_r_p_g_1_1_character_class.html#adb691223ee5006f580d4744929fd8c26">More...</a><br /></td></tr>
<tr class="separator:adb691223ee5006f580d4744929fd8c26"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5ccc7ab4a3039340630901c2671428a8"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_he___arc_1_1_r_p_g_1_1_character_class.html#a5ccc7ab4a3039340630901c2671428a8">GetAgility</a> () const</td></tr>
<tr class="memdesc:a5ccc7ab4a3039340630901c2671428a8"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the Agility of the character.  <a href="class_he___arc_1_1_r_p_g_1_1_character_class.html#a5ccc7ab4a3039340630901c2671428a8">More...</a><br /></td></tr>
<tr class="separator:a5ccc7ab4a3039340630901c2671428a8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7077e043f3aaba9fe29f989778238ddc"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_he___arc_1_1_r_p_g_1_1_character_class.html#a7077e043f3aaba9fe29f989778238ddc">GetStrength</a> () const</td></tr>
<tr class="memdesc:a7077e043f3aaba9fe29f989778238ddc"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the Agility of the character.  <a href="class_he___arc_1_1_r_p_g_1_1_character_class.html#a7077e043f3aaba9fe29f989778238ddc">More...</a><br /></td></tr>
<tr class="separator:a7077e043f3aaba9fe29f989778238ddc"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a139c78daaeff2aec35d4b44e1a06318d"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_he___arc_1_1_r_p_g_1_1_character_class.html#a139c78daaeff2aec35d4b44e1a06318d">GetIntelligence</a> () const</td></tr>
<tr class="memdesc:a139c78daaeff2aec35d4b44e1a06318d"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the Agility of the character.  <a href="class_he___arc_1_1_r_p_g_1_1_character_class.html#a139c78daaeff2aec35d4b44e1a06318d">More...</a><br /></td></tr>
<tr class="separator:a139c78daaeff2aec35d4b44e1a06318d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af32d2f582c0a79d14e704162611390ee"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_he___arc_1_1_r_p_g_1_1_character_class.html#af32d2f582c0a79d14e704162611390ee">GetHp</a> () const</td></tr>
<tr class="memdesc:af32d2f582c0a79d14e704162611390ee"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the HP of the character.  <a href="class_he___arc_1_1_r_p_g_1_1_character_class.html#af32d2f582c0a79d14e704162611390ee">More...</a><br /></td></tr>
<tr class="separator:af32d2f582c0a79d14e704162611390ee"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa130bf887bb9724acb0b743cb001ab82"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_he___arc_1_1_r_p_g_1_1_character_class.html#aa130bf887bb9724acb0b743cb001ab82">GetPerception</a> () const</td></tr>
<tr class="memdesc:aa130bf887bb9724acb0b743cb001ab82"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the name of the character.  <a href="class_he___arc_1_1_r_p_g_1_1_character_class.html#aa130bf887bb9724acb0b743cb001ab82">More...</a><br /></td></tr>
<tr class="separator:aa130bf887bb9724acb0b743cb001ab82"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a79810fa3d8d053c3c20252e248e344bd"><td class="memItemLeft" align="right" valign="top">string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_he___arc_1_1_r_p_g_1_1_character_class.html#a79810fa3d8d053c3c20252e248e344bd">GetName</a> () const</td></tr>
<tr class="memdesc:a79810fa3d8d053c3c20252e248e344bd"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the Perception of the character.  <a href="class_he___arc_1_1_r_p_g_1_1_character_class.html#a79810fa3d8d053c3c20252e248e344bd">More...</a><br /></td></tr>
<tr class="separator:a79810fa3d8d053c3c20252e248e344bd"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:adffa504eb4343ba2060fb41439eb5228"><td class="memItemLeft" align="right" valign="top"><a id="adffa504eb4343ba2060fb41439eb5228"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_he___arc_1_1_r_p_g_1_1_character_class.html#adffa504eb4343ba2060fb41439eb5228">SetName</a> (string name)</td></tr>
<tr class="memdesc:adffa504eb4343ba2060fb41439eb5228"><td class="mdescLeft">&#160;</td><td class="mdescRight">Set the name of the character. <br /></td></tr>
<tr class="separator:adffa504eb4343ba2060fb41439eb5228"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9e5ce353cf6cdb160c7ee7f80b756c07"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_he___arc_1_1_r_p_g_1_1_character_class.html#a9e5ce353cf6cdb160c7ee7f80b756c07">GetLevel</a> () const</td></tr>
<tr class="memdesc:a9e5ce353cf6cdb160c7ee7f80b756c07"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the Level of the character.  <a href="class_he___arc_1_1_r_p_g_1_1_character_class.html#a9e5ce353cf6cdb160c7ee7f80b756c07">More...</a><br /></td></tr>
<tr class="separator:a9e5ce353cf6cdb160c7ee7f80b756c07"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aad2d66fcb380f6d48286db4840684e9b"><td class="memItemLeft" align="right" valign="top"><a id="aad2d66fcb380f6d48286db4840684e9b"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_he___arc_1_1_r_p_g_1_1_character_class.html#aad2d66fcb380f6d48286db4840684e9b">IncreaseLevel</a> ()</td></tr>
<tr class="memdesc:aad2d66fcb380f6d48286db4840684e9b"><td class="mdescLeft">&#160;</td><td class="mdescRight">Increase the level of the character by one. <br /></td></tr>
<tr class="separator:aad2d66fcb380f6d48286db4840684e9b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0ecb6c230a3199d9ab73cca57e85907a"><td class="memItemLeft" align="right" valign="top">shared_ptr&lt; <a class="el" href="class_he___arc_1_1_r_p_g_1_1_i_object.html">IObject</a> &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_he___arc_1_1_r_p_g_1_1_character_class.html#a0ecb6c230a3199d9ab73cca57e85907a">GetObject</a> () const</td></tr>
<tr class="memdesc:a0ecb6c230a3199d9ab73cca57e85907a"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the object held by the character.  <a href="class_he___arc_1_1_r_p_g_1_1_character_class.html#a0ecb6c230a3199d9ab73cca57e85907a">More...</a><br /></td></tr>
<tr class="separator:a0ecb6c230a3199d9ab73cca57e85907a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8ca19e00600c97d925e490e1eca3971e"><td class="memItemLeft" align="right" valign="top">shared_ptr&lt; <a class="el" href="class_he___arc_1_1_r_p_g_1_1_backpack.html">Backpack</a> &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_he___arc_1_1_r_p_g_1_1_character_class.html#a8ca19e00600c97d925e490e1eca3971e">GetBackpack</a> () const</td></tr>
<tr class="memdesc:a8ca19e00600c97d925e490e1eca3971e"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the backpack held by the character.  <a href="class_he___arc_1_1_r_p_g_1_1_character_class.html#a8ca19e00600c97d925e490e1eca3971e">More...</a><br /></td></tr>
<tr class="separator:a8ca19e00600c97d925e490e1eca3971e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a215cd4e01d7f18a374a3ae3b4f594a03"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_he___arc_1_1_r_p_g_1_1_character_class.html#a215cd4e01d7f18a374a3ae3b4f594a03">SetBackpack</a> (shared_ptr&lt; <a class="el" href="class_he___arc_1_1_r_p_g_1_1_backpack.html">Backpack</a> &gt; backpack)</td></tr>
<tr class="memdesc:a215cd4e01d7f18a374a3ae3b4f594a03"><td class="mdescLeft">&#160;</td><td class="mdescRight">Set the backpack held by the character.  <a href="class_he___arc_1_1_r_p_g_1_1_character_class.html#a215cd4e01d7f18a374a3ae3b4f594a03">More...</a><br /></td></tr>
<tr class="separator:a215cd4e01d7f18a374a3ae3b4f594a03"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0900bfb38ea138025e9ee08722894afc"><td class="memItemLeft" align="right" valign="top">shared_ptr&lt; <a class="el" href="class_he___arc_1_1_r_p_g_1_1_i_spell.html">ISpell</a> &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_he___arc_1_1_r_p_g_1_1_character_class.html#a0900bfb38ea138025e9ee08722894afc">GetSpells</a> ()</td></tr>
<tr class="memdesc:a0900bfb38ea138025e9ee08722894afc"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the each spell of the character.  <a href="class_he___arc_1_1_r_p_g_1_1_character_class.html#a0900bfb38ea138025e9ee08722894afc">More...</a><br /></td></tr>
<tr class="separator:a0900bfb38ea138025e9ee08722894afc"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a64f92249bbc471189621ca4b3a84ccd3"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_he___arc_1_1_r_p_g_1_1_character_class.html#a64f92249bbc471189621ca4b3a84ccd3">UseObject</a> (<a class="el" href="class_he___arc_1_1_r_p_g_1_1_character_class.html">CharacterClass</a> *character=nullptr)</td></tr>
<tr class="memdesc:a64f92249bbc471189621ca4b3a84ccd3"><td class="mdescLeft">&#160;</td><td class="mdescRight">Use the object held by the character.  <a href="class_he___arc_1_1_r_p_g_1_1_character_class.html#a64f92249bbc471189621ca4b3a84ccd3">More...</a><br /></td></tr>
<tr class="separator:a64f92249bbc471189621ca4b3a84ccd3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a379b4ceb86d4feb6de1bb27b452eb015"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_he___arc_1_1_r_p_g_1_1_character_class.html#a379b4ceb86d4feb6de1bb27b452eb015">UseSkill</a> (<a class="el" href="class_he___arc_1_1_r_p_g_1_1_character_class.html">CharacterClass</a> *target=nullptr)=0</td></tr>
<tr class="memdesc:a379b4ceb86d4feb6de1bb27b452eb015"><td class="mdescLeft">&#160;</td><td class="mdescRight">Use a skill/spell.  <a href="class_he___arc_1_1_r_p_g_1_1_character_class.html#a379b4ceb86d4feb6de1bb27b452eb015">More...</a><br /></td></tr>
<tr class="separator:a379b4ceb86d4feb6de1bb27b452eb015"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:acf47fd89e0ec51f4be66c6108ec97ea7"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_he___arc_1_1_r_p_g_1_1_character_class.html#acf47fd89e0ec51f4be66c6108ec97ea7">SufferDamage</a> (int damage)</td></tr>
<tr class="memdesc:acf47fd89e0ec51f4be66c6108ec97ea7"><td class="mdescLeft">&#160;</td><td class="mdescRight">Deals damage to the character.  <a href="class_he___arc_1_1_r_p_g_1_1_character_class.html#acf47fd89e0ec51f4be66c6108ec97ea7">More...</a><br /></td></tr>
<tr class="separator:acf47fd89e0ec51f4be66c6108ec97ea7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6881bd26fe586cd8bddb408cad2d05d0"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_he___arc_1_1_r_p_g_1_1_character_class.html#a6881bd26fe586cd8bddb408cad2d05d0">Heal</a> (int amount)</td></tr>
<tr class="memdesc:a6881bd26fe586cd8bddb408cad2d05d0"><td class="mdescLeft">&#160;</td><td class="mdescRight">Heal the character.  <a href="class_he___arc_1_1_r_p_g_1_1_character_class.html#a6881bd26fe586cd8bddb408cad2d05d0">More...</a><br /></td></tr>
<tr class="separator:a6881bd26fe586cd8bddb408cad2d05d0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0c3921c2f64d9b55759e578b50db111b"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_he___arc_1_1_r_p_g_1_1_character_class.html">CharacterClass</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_he___arc_1_1_r_p_g_1_1_character_class.html#a0c3921c2f64d9b55759e578b50db111b">operator=</a> (const <a class="el" href="class_he___arc_1_1_r_p_g_1_1_character_class.html">CharacterClass</a> &amp;character)</td></tr>
<tr class="memdesc:a0c3921c2f64d9b55759e578b50db111b"><td class="mdescLeft">&#160;</td><td class="mdescRight">The assignation (in depth) of a character (copy)  <a href="class_he___arc_1_1_r_p_g_1_1_character_class.html#a0c3921c2f64d9b55759e578b50db111b">More...</a><br /></td></tr>
<tr class="separator:a0c3921c2f64d9b55759e578b50db111b"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pro-attribs"></a>
Protected Attributes</h2></td></tr>
<tr class="memitem:a140f440d1d3332267268791ad9a2cc3e"><td class="memItemLeft" align="right" valign="top"><a id="a140f440d1d3332267268791ad9a2cc3e"></a>
<a class="el" href="class_he___arc_1_1_r_p_g_1_1_dice.html">Dice</a>&lt; int &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_he___arc_1_1_r_p_g_1_1_character_class.html#a140f440d1d3332267268791ad9a2cc3e">m_statDice</a> = <a class="el" href="class_he___arc_1_1_r_p_g_1_1_dice.html">Dice</a>&lt;int&gt;(20)</td></tr>
<tr class="memdesc:a140f440d1d3332267268791ad9a2cc3e"><td class="mdescLeft">&#160;</td><td class="mdescRight">The dice used for rolls when a stats is used (like strengh, agility, ...) <br /></td></tr>
<tr class="separator:a140f440d1d3332267268791ad9a2cc3e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a569272e38e69aaf6f1285a9e3811f95c"><td class="memItemLeft" align="right" valign="top"><a id="a569272e38e69aaf6f1285a9e3811f95c"></a>
int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_he___arc_1_1_r_p_g_1_1_character_class.html#a569272e38e69aaf6f1285a9e3811f95c">m_level</a> {1}</td></tr>
<tr class="memdesc:a569272e38e69aaf6f1285a9e3811f95c"><td class="mdescLeft">&#160;</td><td class="mdescRight">The level of the character. <br /></td></tr>
<tr class="separator:a569272e38e69aaf6f1285a9e3811f95c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:abda9c8d99244d23c15c56ac8d9ff0617"><td class="memItemLeft" align="right" valign="top"><a id="abda9c8d99244d23c15c56ac8d9ff0617"></a>
int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_he___arc_1_1_r_p_g_1_1_character_class.html#abda9c8d99244d23c15c56ac8d9ff0617">m_strength</a> {0}</td></tr>
<tr class="memdesc:abda9c8d99244d23c15c56ac8d9ff0617"><td class="mdescLeft">&#160;</td><td class="mdescRight">The strength of the character. This characteristic is the physical power. <br /></td></tr>
<tr class="separator:abda9c8d99244d23c15c56ac8d9ff0617"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aceed2329152d2a179c8c888daf5a09bd"><td class="memItemLeft" align="right" valign="top"><a id="aceed2329152d2a179c8c888daf5a09bd"></a>
int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_he___arc_1_1_r_p_g_1_1_character_class.html#aceed2329152d2a179c8c888daf5a09bd">m_agility</a> {0}</td></tr>
<tr class="memdesc:aceed2329152d2a179c8c888daf5a09bd"><td class="mdescLeft">&#160;</td><td class="mdescRight">The agility of the character. This characteristic is the dexterity, reflexes. <br /></td></tr>
<tr class="separator:aceed2329152d2a179c8c888daf5a09bd"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab7f3dbdf4a92a55e2ecf810f984c33c1"><td class="memItemLeft" align="right" valign="top"><a id="ab7f3dbdf4a92a55e2ecf810f984c33c1"></a>
int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_he___arc_1_1_r_p_g_1_1_character_class.html#ab7f3dbdf4a92a55e2ecf810f984c33c1">m_intelligence</a> {0}</td></tr>
<tr class="memdesc:ab7f3dbdf4a92a55e2ecf810f984c33c1"><td class="mdescLeft">&#160;</td><td class="mdescRight">The intelligence of the character. This characteristic is the mental power. <br /></td></tr>
<tr class="separator:ab7f3dbdf4a92a55e2ecf810f984c33c1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a79735b9d6e6d9201385dd97efe545a53"><td class="memItemLeft" align="right" valign="top"><a id="a79735b9d6e6d9201385dd97efe545a53"></a>
int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_he___arc_1_1_r_p_g_1_1_character_class.html#a79735b9d6e6d9201385dd97efe545a53">m_perception</a> {0}</td></tr>
<tr class="memdesc:a79735b9d6e6d9201385dd97efe545a53"><td class="mdescLeft">&#160;</td><td class="mdescRight">The perception of the character. This characteristic is ability to examine a room, traps, see the vital point. <br /></td></tr>
<tr class="separator:a79735b9d6e6d9201385dd97efe545a53"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5a98c6a47e818e86ac75a0166bb8c3c0"><td class="memItemLeft" align="right" valign="top"><a id="a5a98c6a47e818e86ac75a0166bb8c3c0"></a>
int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_he___arc_1_1_r_p_g_1_1_character_class.html#a5a98c6a47e818e86ac75a0166bb8c3c0">m_hp</a> {0}</td></tr>
<tr class="memdesc:a5a98c6a47e818e86ac75a0166bb8c3c0"><td class="mdescLeft">&#160;</td><td class="mdescRight">The Health point (HP) of the character. This characteristic is the current health point. <br /></td></tr>
<tr class="separator:a5a98c6a47e818e86ac75a0166bb8c3c0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad8821a9a8c02c7db1db065a48ceedfc7"><td class="memItemLeft" align="right" valign="top"><a id="ad8821a9a8c02c7db1db065a48ceedfc7"></a>
string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_he___arc_1_1_r_p_g_1_1_character_class.html#ad8821a9a8c02c7db1db065a48ceedfc7">m_name</a> {&quot;no_name&quot;}</td></tr>
<tr class="memdesc:ad8821a9a8c02c7db1db065a48ceedfc7"><td class="mdescLeft">&#160;</td><td class="mdescRight">The name of the character. <br /></td></tr>
<tr class="separator:ad8821a9a8c02c7db1db065a48ceedfc7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0acb8820b5a72d70df97395c7546fdac"><td class="memItemLeft" align="right" valign="top"><a id="a0acb8820b5a72d70df97395c7546fdac"></a>
shared_ptr&lt; <a class="el" href="class_he___arc_1_1_r_p_g_1_1_i_object.html">IObject</a> &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_he___arc_1_1_r_p_g_1_1_character_class.html#a0acb8820b5a72d70df97395c7546fdac">m_pObject</a> {nullptr}</td></tr>
<tr class="memdesc:a0acb8820b5a72d70df97395c7546fdac"><td class="mdescLeft">&#160;</td><td class="mdescRight">The object held by the the character. <br /></td></tr>
<tr class="separator:a0acb8820b5a72d70df97395c7546fdac"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aebb463c3a8725b3ac6e1bac04fad0315"><td class="memItemLeft" align="right" valign="top"><a id="aebb463c3a8725b3ac6e1bac04fad0315"></a>
shared_ptr&lt; <a class="el" href="class_he___arc_1_1_r_p_g_1_1_backpack.html">Backpack</a> &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_he___arc_1_1_r_p_g_1_1_character_class.html#aebb463c3a8725b3ac6e1bac04fad0315">m_backpack</a></td></tr>
<tr class="memdesc:aebb463c3a8725b3ac6e1bac04fad0315"><td class="mdescLeft">&#160;</td><td class="mdescRight">The backpack (inventory) of the character. <br /></td></tr>
<tr class="separator:aebb463c3a8725b3ac6e1bac04fad0315"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a74cff61680b7b76ba8a80db23b8fd798"><td class="memItemLeft" align="right" valign="top">shared_ptr&lt; <a class="el" href="class_he___arc_1_1_r_p_g_1_1_i_spell.html">ISpell</a> &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_he___arc_1_1_r_p_g_1_1_character_class.html#a74cff61680b7b76ba8a80db23b8fd798">m_spells</a></td></tr>
<tr class="memdesc:a74cff61680b7b76ba8a80db23b8fd798"><td class="mdescLeft">&#160;</td><td class="mdescRight">Spells of the character.  <a href="class_he___arc_1_1_r_p_g_1_1_character_class.html#a74cff61680b7b76ba8a80db23b8fd798">More...</a><br /></td></tr>
<tr class="separator:a74cff61680b7b76ba8a80db23b8fd798"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="friends"></a>
Friends</h2></td></tr>
<tr class="memitem:a2c67f6e6eead62292fd88a9034656474"><td class="memItemLeft" align="right" valign="top">ostream &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_he___arc_1_1_r_p_g_1_1_character_class.html#a2c67f6e6eead62292fd88a9034656474">operator&lt;&lt;</a> (ostream &amp;s, const <a class="el" href="class_he___arc_1_1_r_p_g_1_1_character_class.html">CharacterClass</a> &amp;character)</td></tr>
<tr class="memdesc:a2c67f6e6eead62292fd88a9034656474"><td class="mdescLeft">&#160;</td><td class="mdescRight">Show the statistics of the character.  <a href="class_he___arc_1_1_r_p_g_1_1_character_class.html#a2c67f6e6eead62292fd88a9034656474">More...</a><br /></td></tr>
<tr class="separator:a2c67f6e6eead62292fd88a9034656474"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>Class for the <a class="el" href="class_he___arc_1_1_r_p_g_1_1_character_class.html" title="Class for the CharacterClass. A character class is the &quot;type&quot; (the class) of a character,...">CharacterClass</a>. A character class is the "type" (the class) of a character, like a warrior or a wizard. This class contains the base attribute and commons methods of each type of character. </p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="aafe993f8df4d10236808bf056074d5cc"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aafe993f8df4d10236808bf056074d5cc">&#9670;&nbsp;</a></span>CharacterClass()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">CharacterClass::CharacterClass </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>level</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>strength</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>agility</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>intelligence</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>perception</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>hp</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>name</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">shared_ptr&lt; <a class="el" href="class_he___arc_1_1_r_p_g_1_1_i_object.html">IObject</a> &gt;&#160;</td>
          <td class="paramname"><em>object</em> = <code>nullptr</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Construct a new Character Class object. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">level</td><td>The level of the character </td></tr>
    <tr><td class="paramname">strength</td><td>The strength of the character </td></tr>
    <tr><td class="paramname">agility</td><td>The agility of the character </td></tr>
    <tr><td class="paramname">intelligence</td><td>The intelligence of the character </td></tr>
    <tr><td class="paramname">perception</td><td>The perception of the character </td></tr>
    <tr><td class="paramname">hp</td><td>The Health point (HP) of the character </td></tr>
    <tr><td class="paramname">name</td><td>The name of the character </td></tr>
    <tr><td class="paramname">object</td><td>The object held by the the character </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="ad4f8371c791c5994eee4a81d230b27c1"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad4f8371c791c5994eee4a81d230b27c1">&#9670;&nbsp;</a></span>Clone()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="class_he___arc_1_1_r_p_g_1_1_character_class.html">CharacterClass</a>* He_Arc::RPG::CharacterClass::Clone </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Create a clone of the character. </p>
<dl class="section return"><dt>Returns</dt><dd>CharacterClass* The clonned character </dd></dl>
<dl class="section remark"><dt>Remarks</dt><dd>Source of the clone design for polymorphism : <a href="https://stackoverflow.com/questions/28273777/c-clone-function-in-abstract-class">https://stackoverflow.com/questions/28273777/c-clone-function-in-abstract-class</a> <a href="https://katyscode.wordpress.com/2013/08/22/c-polymorphic-cloning-and-the-crtp-curiously-recurring-template-pattern/">https://katyscode.wordpress.com/2013/08/22/c-polymorphic-cloning-and-the-crtp-curiously-recurring-template-pattern/</a> <a href="https://stackoverflow.com/questions/6206977/copying-c-abstract-classes">https://stackoverflow.com/questions/6206977/copying-c-abstract-classes</a> </dd></dl>

<p>Implemented in <a class="el" href="class_he___arc_1_1_r_p_g_1_1_wizard.html#ac534d1cb82583d5a74c6d06fd23f5f59">He_Arc::RPG::Wizard</a>, <a class="el" href="class_he___arc_1_1_r_p_g_1_1_warrior.html#a62f13ee7042201511ab24246764653ca">He_Arc::RPG::Warrior</a>, <a class="el" href="class_he___arc_1_1_r_p_g_1_1_slime.html#a53bf2d00e5f6ede780d4436b94d88045">He_Arc::RPG::Slime</a>, and <a class="el" href="class_he___arc_1_1_r_p_g_1_1_skeleton.html#aeb9ffbef5ffd53152c0bcb5723b596f8">He_Arc::RPG::Skeleton</a>.</p>

</div>
</div>
<a id="a5ccc7ab4a3039340630901c2671428a8"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a5ccc7ab4a3039340630901c2671428a8">&#9670;&nbsp;</a></span>GetAgility()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int CharacterClass::GetAgility </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Get the Agility of the character. </p>
<dl class="section return"><dt>Returns</dt><dd>int The agility of the character </dd></dl>

</div>
</div>
<a id="a8ca19e00600c97d925e490e1eca3971e"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a8ca19e00600c97d925e490e1eca3971e">&#9670;&nbsp;</a></span>GetBackpack()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">shared_ptr&lt; <a class="el" href="class_he___arc_1_1_r_p_g_1_1_backpack.html">Backpack</a> &gt; CharacterClass::GetBackpack </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Get the backpack held by the character. </p>
<dl class="section return"><dt>Returns</dt><dd>shared_ptr&lt;Backpack&gt; the pointer of the backpack held by the character </dd></dl>

</div>
</div>
<a id="ae69612164d99e1c4b84b05912d03d72e"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae69612164d99e1c4b84b05912d03d72e">&#9670;&nbsp;</a></span>GetClassTypeName()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual string He_Arc::RPG::CharacterClass::GetClassTypeName </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Get the name of the class For exemple; if called with this class, it would return "CharacterClass" or somthings like this. </p>
<dl class="section remark"><dt>Remarks</dt><dd>use it because "typeid(Class)" will show somethings like "Something95Something" </dd></dl>
<dl class="section return"><dt>Returns</dt><dd>string An human identifying name for the class </dd></dl>

<p>Implemented in <a class="el" href="class_he___arc_1_1_r_p_g_1_1_wizard.html#a20d755ae7b54d06d887d95ceaa6c065e">He_Arc::RPG::Wizard</a>, <a class="el" href="class_he___arc_1_1_r_p_g_1_1_warrior.html#a745467f29720ff3045d3f7e3451e1baa">He_Arc::RPG::Warrior</a>, <a class="el" href="class_he___arc_1_1_r_p_g_1_1_slime.html#a1eaf57d26af00bff92c3078e4606abd8">He_Arc::RPG::Slime</a>, <a class="el" href="class_he___arc_1_1_r_p_g_1_1_skeleton.html#ad8ac9797a251109390e4baae626d5793">He_Arc::RPG::Skeleton</a>, and <a class="el" href="class_he___arc_1_1_r_p_g_1_1_necromancer.html#ae3fb420844cfe5cd56d40c0c6ea1d54e">He_Arc::RPG::Necromancer</a>.</p>

</div>
</div>
<a id="af32d2f582c0a79d14e704162611390ee"></a>
<h2 class="memtitle"><span class="permalink"><a href="#af32d2f582c0a79d14e704162611390ee">&#9670;&nbsp;</a></span>GetHp()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int CharacterClass::GetHp </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Get the HP of the character. </p>
<dl class="section return"><dt>Returns</dt><dd>int The HP of the character </dd></dl>

</div>
</div>
<a id="a139c78daaeff2aec35d4b44e1a06318d"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a139c78daaeff2aec35d4b44e1a06318d">&#9670;&nbsp;</a></span>GetIntelligence()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int CharacterClass::GetIntelligence </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Get the Agility of the character. </p>
<dl class="section return"><dt>Returns</dt><dd>int The Intelligence of the character </dd></dl>

</div>
</div>
<a id="a9e5ce353cf6cdb160c7ee7f80b756c07"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a9e5ce353cf6cdb160c7ee7f80b756c07">&#9670;&nbsp;</a></span>GetLevel()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int CharacterClass::GetLevel </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Get the Level of the character. </p>
<dl class="section return"><dt>Returns</dt><dd>int Level of the character </dd></dl>

</div>
</div>
<a id="a79810fa3d8d053c3c20252e248e344bd"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a79810fa3d8d053c3c20252e248e344bd">&#9670;&nbsp;</a></span>GetName()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">string CharacterClass::GetName </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Get the Perception of the character. </p>
<dl class="section return"><dt>Returns</dt><dd>string The name of the character </dd></dl>

</div>
</div>
<a id="a0ecb6c230a3199d9ab73cca57e85907a"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a0ecb6c230a3199d9ab73cca57e85907a">&#9670;&nbsp;</a></span>GetObject()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">shared_ptr&lt; <a class="el" href="class_he___arc_1_1_r_p_g_1_1_i_object.html">IObject</a> &gt; CharacterClass::GetObject </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Get the object held by the character. </p>
<dl class="section return"><dt>Returns</dt><dd>shared_ptr&lt;IObject&gt; The pointer of the object held by the character </dd></dl>

</div>
</div>
<a id="aa130bf887bb9724acb0b743cb001ab82"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa130bf887bb9724acb0b743cb001ab82">&#9670;&nbsp;</a></span>GetPerception()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int CharacterClass::GetPerception </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Get the name of the character. </p>
<dl class="section return"><dt>Returns</dt><dd>string The name of the character </dd></dl>

</div>
</div>
<a id="a0900bfb38ea138025e9ee08722894afc"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a0900bfb38ea138025e9ee08722894afc">&#9670;&nbsp;</a></span>GetSpells()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">shared_ptr&lt; <a class="el" href="class_he___arc_1_1_r_p_g_1_1_i_spell.html">ISpell</a> &gt; CharacterClass::GetSpells </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Get the each spell of the character. </p>
<dl class="section return"><dt>Returns</dt><dd>vector&lt;shared_ptr&lt;ISpell&gt;&gt; spells who can be rise by the character </dd></dl>

</div>
</div>
<a id="a7077e043f3aaba9fe29f989778238ddc"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a7077e043f3aaba9fe29f989778238ddc">&#9670;&nbsp;</a></span>GetStrength()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int CharacterClass::GetStrength </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Get the Agility of the character. </p>
<dl class="section return"><dt>Returns</dt><dd>int The Strength of the character </dd></dl>

</div>
</div>
<a id="a6881bd26fe586cd8bddb408cad2d05d0"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a6881bd26fe586cd8bddb408cad2d05d0">&#9670;&nbsp;</a></span>Heal()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void CharacterClass::Heal </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>amount</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Heal the character. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">amount</td><td>How many life points are given to the character </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="adb691223ee5006f580d4744929fd8c26"></a>
<h2 class="memtitle"><span class="permalink"><a href="#adb691223ee5006f580d4744929fd8c26">&#9670;&nbsp;</a></span>Interact()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void CharacterClass::Interact </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="class_he___arc_1_1_r_p_g_1_1_character_class.html">CharacterClass</a> &amp;&#160;</td>
          <td class="paramname"><em>character</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Make an interaction between 2 characters. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">character</td><td>The other character who interact </td></tr>
  </table>
  </dd>
</dl>

<p>Implemented in <a class="el" href="class_he___arc_1_1_r_p_g_1_1_wizard.html#a6bcb1d7c894e467cf8696ad0e947e0ac">He_Arc::RPG::Wizard</a>, <a class="el" href="class_he___arc_1_1_r_p_g_1_1_warrior.html#aa6207c6bf164e5bbf0a4d7abb06ce2ed">He_Arc::RPG::Warrior</a>, <a class="el" href="class_he___arc_1_1_r_p_g_1_1_slime.html#a757a3d40fd99232da698675833674a43">He_Arc::RPG::Slime</a>, and <a class="el" href="class_he___arc_1_1_r_p_g_1_1_skeleton.html#a118110034df7b4cee5b5dc9cedd15340">He_Arc::RPG::Skeleton</a>.</p>

</div>
</div>
<a id="a0c3921c2f64d9b55759e578b50db111b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a0c3921c2f64d9b55759e578b50db111b">&#9670;&nbsp;</a></span>operator=()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="class_he___arc_1_1_r_p_g_1_1_character_class.html">CharacterClass</a> &amp; CharacterClass::operator= </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="class_he___arc_1_1_r_p_g_1_1_character_class.html">CharacterClass</a> &amp;&#160;</td>
          <td class="paramname"><em>character</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>The assignation (in depth) of a character (copy) </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">character</td><td></td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd><a class="el" href="class_he___arc_1_1_r_p_g_1_1_character_class.html" title="Class for the CharacterClass. A character class is the &quot;type&quot; (the class) of a character,...">CharacterClass</a>&amp; </dd></dl>

</div>
</div>
<a id="a215cd4e01d7f18a374a3ae3b4f594a03"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a215cd4e01d7f18a374a3ae3b4f594a03">&#9670;&nbsp;</a></span>SetBackpack()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void CharacterClass::SetBackpack </td>
          <td>(</td>
          <td class="paramtype">shared_ptr&lt; <a class="el" href="class_he___arc_1_1_r_p_g_1_1_backpack.html">Backpack</a> &gt;&#160;</td>
          <td class="paramname"><em>backpack</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Set the backpack held by the character. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">backpack</td><td><a class="el" href="class_he___arc_1_1_r_p_g_1_1_backpack.html" title="Class for the Backpack, It&#39;s an portable inventory, who can be held by a character during is adventur...">Backpack</a> to attribuate to the character </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="acf47fd89e0ec51f4be66c6108ec97ea7"></a>
<h2 class="memtitle"><span class="permalink"><a href="#acf47fd89e0ec51f4be66c6108ec97ea7">&#9670;&nbsp;</a></span>SufferDamage()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void CharacterClass::SufferDamage </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>damage</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Deals damage to the character. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">damage</td><td>the amount of damage the character takes </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a64f92249bbc471189621ca4b3a84ccd3"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a64f92249bbc471189621ca4b3a84ccd3">&#9670;&nbsp;</a></span>UseObject()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void CharacterClass::UseObject </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="class_he___arc_1_1_r_p_g_1_1_character_class.html">CharacterClass</a> *&#160;</td>
          <td class="paramname"><em>character</em> = <code>nullptr</code></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Use the object held by the character. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">character</td><td>The target on which to use the object (if nullptr, the target is this) </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a379b4ceb86d4feb6de1bb27b452eb015"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a379b4ceb86d4feb6de1bb27b452eb015">&#9670;&nbsp;</a></span>UseSkill()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual void He_Arc::RPG::CharacterClass::UseSkill </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="class_he___arc_1_1_r_p_g_1_1_character_class.html">CharacterClass</a> *&#160;</td>
          <td class="paramname"><em>target</em> = <code>nullptr</code></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Use a skill/spell. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">target</td><td>the target of the spell (if nullptr, the target is this) </td></tr>
  </table>
  </dd>
</dl>

<p>Implemented in <a class="el" href="class_he___arc_1_1_r_p_g_1_1_wizard.html#a9aabe9d8f966c6024c226b8ee46aeb2e">He_Arc::RPG::Wizard</a>, <a class="el" href="class_he___arc_1_1_r_p_g_1_1_warrior.html#a4ed7db4fef11887702f3028f047698cc">He_Arc::RPG::Warrior</a>, <a class="el" href="class_he___arc_1_1_r_p_g_1_1_slime.html#af20b8cbaa9e44a25b6ab27093b4d8463">He_Arc::RPG::Slime</a>, and <a class="el" href="class_he___arc_1_1_r_p_g_1_1_skeleton.html#ae137fbdfde27a415b8ad9b2178170194">He_Arc::RPG::Skeleton</a>.</p>

</div>
</div>
<h2 class="groupheader">Friends And Related Function Documentation</h2>
<a id="a2c67f6e6eead62292fd88a9034656474"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a2c67f6e6eead62292fd88a9034656474">&#9670;&nbsp;</a></span>operator&lt;&lt;</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">ostream&amp; operator&lt;&lt; </td>
          <td>(</td>
          <td class="paramtype">ostream &amp;&#160;</td>
          <td class="paramname"><em>s</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="class_he___arc_1_1_r_p_g_1_1_character_class.html">CharacterClass</a> &amp;&#160;</td>
          <td class="paramname"><em>character</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">friend</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Show the statistics of the character. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">s</td><td></td></tr>
    <tr><td class="paramname">character</td><td>The character to show </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>ostream&amp; </dd></dl>

</div>
</div>
<h2 class="groupheader">Member Data Documentation</h2>
<a id="a74cff61680b7b76ba8a80db23b8fd798"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a74cff61680b7b76ba8a80db23b8fd798">&#9670;&nbsp;</a></span>m_spells</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">shared_ptr&lt;<a class="el" href="class_he___arc_1_1_r_p_g_1_1_i_spell.html">ISpell</a>&gt; He_Arc::RPG::CharacterClass::m_spells</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Spells of the character. </p>
<dl class="section remark"><dt>Remarks</dt><dd>normally, that would be a "vector&lt;shared_ptr&lt;ISpell&gt;" but for now, the classes have only one spell Multiple spell will comming for a future version </dd></dl>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li>cpp_filrouge_iscj_allemann/include/Character/<a class="el" href="_character_class_8hpp_source.html">CharacterClass.hpp</a></li>
<li>cpp_filrouge_iscj_allemann/src/Character/<a class="el" href="_character_class_8cpp.html">CharacterClass.cpp</a></li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.1
</small></address>
</body>
</html>
